var APIBase = require("../../api.base");
var system = require("../../../system");
var settings = require("../../../../config/settings");
class QcAPI extends APIBase {
    constructor() {
        super();
        this.aliyunqcSve = system.getObject("service.qcutils.aliyunqcSve");
    }
    /**
      * 接口跳转-POST请求
      * action_process  执行的流程
      * action_type     执行的类型
      * action_body     执行的参数
      */
    async springBoard(pobj, qobj, req) {
        if (!pobj.actionType) {
            return system.getResult(null, "actionType参数不能为空");
        }
        if (pobj.actionType == 'getPolicyNeedList' || pobj.actionType == 'submitPolicyNeedNotes') {
            if (!pobj.userInfo) {
                return system.getResult(system.noLogin, "user no login!");
            }
            if (!pobj.appInfo) {
                return system.getResult(system.noLogin, "app is null!");
            }
        }
        var result = await this.opActionProcess(pobj, pobj.actionType, req);
        return result;
    }
    async opActionProcess(pobj, action_type, req) {
        var opResult = null;
        switch (action_type) {
            case "receiveProgrammeNo"://接收方案编号(方案推送至阿里后,接收保存方案信息)
                opResult = await this.aliyunqcSve.receiveProgrammeNo(pobj);
                break;
            case "submitIcpProgramme"://icp方案提交
                opResult = await this.aliyunqcSve.submitIcpProgramme(pobj);
                break;
            // case "submitIcpMaterial"://icp材料提交
            //     opResult = await this.aliyunqcSve.submitIcpMaterial(pobj);
            //     break;
            case "acceptIcpPartnerNotification"://icp通知状态变更
                opResult = await this.aliyunqcSve.acceptIcpPartnerNotification(pobj);
                break;
            case "abolishIcpProgramme"://服务商icp方案关闭
                opResult = await this.aliyunqcSve.abolishIcpProgramme(pobj);
                break;
            case "getIcpProgrammeDetail"://获取icp方案
                opResult = await this.aliyunqcSve.getIcpProgrammeDetail(pobj);
                break;
            case "getNeedSolutionDetailByUser"://获取方案详情
                opResult = await this.aliyunqcSve.getNeedSolutionDetailByUser(pobj);
                break;
            case "receiveIcpStatusNotify"://接收渠道方案状态变更通知2.3
                opResult = await this.aliyunqcSve.receiveIcpStatusNotify(pobj);
                break;
            case "receiveIcpFeedback"://接收icp用户方案反馈2.2
                opResult = await this.aliyunqcSve.receiveIcpFeedback(pobj);
                break;
            case "getIcpProgrammeDetail"://获取方案详情（内部调用）
                opResult = await this.aliyunqcSve.getIcpProgrammeDetail(pobj);
                break;
            case "getProgrammeInfoByChannelNeedNo"://获取需求方案列表
                opResult = await this.aliyunqcSve.getProgrammeInfoByChannelNeedNo(pobj);
                break;

            case "serviceProviderSubmitMaterial"://交付商提交材料信息
                opResult = await this.aliyunqcSve.serviceProviderSubmitMaterial(pobj);
                break;
            case "serviceProviderNotification"://交付商通知状态变更
                opResult = await this.aliyunqcSve.serviceProviderNotification(pobj);
                break;
            case "closeOrderDelivery"://交付商关闭交付单
                opResult = await this.aliyunqcSve.closeOrderDelivery(pobj);
                break;
            case "abolishIcpProgrammeByNeed"://前端关闭ICP需求及方案
                opResult = await this.aliyunqcSve.abolishIcpProgrammeByNeed(pobj);
                break;
            case "receiveIcpConfirmUrl"://前端关闭ICP需求及方案
                opResult = await this.aliyunqcSve.receiveIcpConfirmUrl(pobj);
                break;
            default:
                opResult = system.getResult(null, "action_type参数错误");
                break;
        }
        return opResult;
    }

}
module.exports = QcAPI;